'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 12 April 2008 at 8:51:58 am'!

!ChangeList methodsFor: 'menu actions' stamp: 'jmv 4/12/2008 08:32'!
removeExistingMethodVersions
	"Remove all up to date version of entries from the receiver"
	"Modified to also remove up to date classDefinitions"
	| newChangeList newList str keep cls sel name |
	newChangeList _ OrderedCollection new.
	newList _ OrderedCollection new.

	changeList with: list do: [ :chRec :strNstamp | 
			keep _ true.
			(cls _ chRec methodClass) ifNotNil:[
				str _ chRec string.
				sel _ cls parserClass new parseSelector: str.
				keep _ (cls sourceCodeAt: sel ifAbsent:['']) asString ~= str.
			].
			(chRec type == #classDefinition and: [
					name _ chRec methodClassName.
					Smalltalk includesKey: name]) ifTrue: [
				cls _ Smalltalk at: name.
				chRec isMetaClassChange ifTrue: [ cls _ cls class ].
				keep _ cls definition ~= chRec text.
			].
			keep ifTrue:[
				newChangeList add: chRec.
				newList add: strNstamp]].
	newChangeList size < changeList size
		ifTrue: [
			changeList _ newChangeList.
			list _ newList.
			listIndex _ 0.
			listSelections _ Array new: list size withAll: false].
	self changed: #list! !

